QwtSplineC1(3)

NAME
QwtSplineC1 - Base class for spline interpolations providing a first order parametric continuity ( C1 ) between adjoining curves.

SYNOPSIS

#include <qwt_spline.h>

Inherits QwtSplineG1.

Inherited by QwtSplineC2, and QwtSplineLocal.

  Public Member Functions
QwtSplineC1 ()
Constructor.
virtual ~QwtSplineC1 ()
Destructor.
virtual QPainterPath painterPath (const QPolygonF &) const override
Calculate an interpolated painter path.
virtual QVector< QLineF > bezierControlLines (const QPolygonF &) const override
Interpolate a curve with Bezier curves.
virtual QPolygonF equidistantPolygon (const QPolygonF &, double distance, bool withNodes) const override
Find an interpolated polygon with 'equidistant' points.
virtual QVector< QwtSplinePolynomial > polynomials (const QPolygonF &) const
Calculate the interpolating polynomials for a non parametric spline.
virtual QVector< double > slopes (const QPolygonF &) const =0
Find the first derivative at the control points.
virtual double slopeAtBeginning (const QPolygonF &, double slopeNext) const
virtual double slopeAtEnd (const QPolygonF &, double slopeBefore) const

  Additional Inherited Members

Detailed Description

Base class for spline interpolations providing a first order parametric continuity ( C1 ) between adjoining curves. All interpolations with C1 continuity are based on rules for finding the 1. derivate at some control points.

In case of non parametric splines those points are the curve points, while for parametric splines the calculation is done twice using a parameter value t.

See also
    QwtSplineParametrization

Definition at line 235 of file qwt_spline.h.

Constructor & Destructor Documentation

  QwtSplineC1::QwtSplineC1 ()

Constructor. The default setting is a non closing spline with no parametrization ( QwtSplineParametrization::ParameterX ).

See also
    QwtSpline::setParametrization(), QwtSpline::setBoundaryType()

Definition at line 962 of file qwt_spline.cpp.

Member Function Documentation

  QVector< QLineF > QwtSplineC1::bezierControlLines (const QPolygonF & points) const [override], [virtual]

Interpolate a curve with Bezier curves. Interpolates a polygon piecewise with cubic Bezier curves and returns the 2 control points of each curve as QLineF.

Parameters
    points Control points

Returns
    Control points of the interpolating Bezier curves

Implements QwtSplineInterpolating.

Reimplemented in QwtSplineCubic, QwtSplineLocal, and QwtSplineC2.

Definition at line 1101 of file qwt_spline.cpp.

  QPolygonF QwtSplineC1::equidistantPolygon (const QPolygonF & points, double distance, bool withNodes) const [override], [virtual]

Find an interpolated polygon with 'equidistant' points. The implementation is optimzed for non parametric curves ( QwtSplineParametrization::ParameterX ) and falls back to QwtSpline::equidistantPolygon() otherwise.

Parameters
    points Control nodes of the spline
    distance Distance between 2 points according to the parametrization
    withNodes When true, also add the control nodes ( even if not being equidistant )

Returns
    Interpolating polygon

See also
    QwtSpline::equidistantPolygon()

Reimplemented from QwtSplineInterpolating.

Reimplemented in QwtSplineC2.

Definition at line 1167 of file qwt_spline.cpp.

  QPainterPath QwtSplineC1::painterPath (const QPolygonF & points) const [override], [virtual]

Calculate an interpolated painter path. Interpolates a polygon piecewise into cubic Bezier curves and returns them as QPainterPath.

The implementation calculates the slopes at the control points and converts them into painter path elements in an additional loop.

Parameters
    points Control points

Returns
    QPainterPath Painter path, that can be rendered by QPainter

Note
    Derived spline classes might overload painterPath() to avoid the extra loops for converting results into a QPainterPath

Reimplemented from QwtSplineInterpolating.

Reimplemented in QwtSplineLocal, QwtSplineCubic, and QwtSplineC2.

Definition at line 1043 of file qwt_spline.cpp.

  QVector< QwtSplinePolynomial > QwtSplineC1::polynomials (const QPolygonF & points) const [virtual]

Calculate the interpolating polynomials for a non parametric spline. C1 spline interpolations are based on finding values for the first derivates at the control points. The interpolating polynomials can be calculated from the the first derivates using QwtSplinePolynomial::fromSlopes().

The default implementation is a two pass calculation. In derived classes it might be overloaded by a one pass implementation.

Parameters
    points Control points

Returns
    Interpolating polynomials

Note
    The x coordinates need to be increasing or decreasing

Reimplemented in QwtSplineLocal, QwtSplineCubic, and QwtSplineC2.

Definition at line 1201 of file qwt_spline.cpp.

  double QwtSplineC1::slopeAtBeginning (const QPolygonF & points, double slopeNext) const [virtual]

Parameters
    points Control points
    slopeNext Value of the first derivative at the second point

Returns
    value of the first derivative at the first point

See also
    slopeAtEnd(), QwtSpline::boundaryCondition(), QwtSpline::boundaryValue()

Definition at line 979 of file qwt_spline.cpp.

  double QwtSplineC1::slopeAtEnd (const QPolygonF & points, double slopeBefore) const [virtual]

Parameters
    points Control points
    slopeBefore Value of the first derivative at the point before the last one

Returns
    value of the first derivative at the last point

See also
    slopeAtBeginning(), QwtSpline::boundaryCondition(), QwtSpline::boundaryValue()

Definition at line 997 of file qwt_spline.cpp.

  QVector< double > QwtSplineC1::slopes (const QPolygonF & points) const [pure virtual]

Find the first derivative at the control points.

Parameters
    points Control nodes of the spline

Returns
    Vector with the values of the 2nd derivate at the control points

Note
    The x coordinates need to be increasing or decreasing

Implemented in QwtSplineLocal, QwtSplineCubic, and QwtSplineC2.

Author

Generated automatically by Doxygen for Qwt User's Guide from the source code.